# SIG/AltArch meeting 2023-12-15

## Attendees:
    * Sherif
    * Bryan
    * Pablo Greco
    * Neil Hanlon
    * Skip Grube

## Follow Ups

* Libre Compute - Try/Investigate using vendor tree to build uboot  - Pratham
* Investigate `arm-image-installer` script/tool for helping write disk images for specific boards - Sherif (?)
* Odroid N2 - Track installability
* Orange Pi 5 - Track installability
* Rock5b - Track installability
* Libre Computing Boards (3)
* Maintenance - Importing dependencies from Fedora/EPEL
    * Neil is working on this as part of SIG/HPC, too
* Document process on backporting uboot and kernels - Pablo
    * To include information on how we work and interact with upstreams, with examples! - Sherif
* Check and investigate which boards have hardcoded grubx64 paths in their uboot; address them

## Discussions

* Neil provided Sherif with 2 RPi CM4s (+ IO boards), an RPi5, and a SiFive VF2 (RiscV) at SC23 in November
* Need to work on integrating SBC and related changes into SIG/Kernel mainline in order to have unified kernel
    * Bryan has tried mainline kernel, but it isn't booting -- ends up in dracut shell.
        * Will figure out how to capture logs via serial
        * Libre Tritium H5
* It's all Skip's fault
* 32-bit arm (armhfp/arm7vl) Rocky Port
    * Sherif has some odroid boards from work he can donate
        * Odroid XU4 x2
        * Odroid XU4Q x1 - XU4 w/ massive heatsink
    * Current status (per Pablo)
        * have the full bootstrap up to 9.1; we need to start building atop it
        * need to add Peridot support for armhfp (i can't remember if we included the arch as an option)
        * where will we host the odroid boards from Sherif
    * Most of the SBCs for arm7vl/armhfp are not powerful enough to be good build hosts. Maybe we should try Honeycombs? (Solid-run)
        * Pablo used his honeycomb and a fedora image to do the initial bootstrap builds
        * Neil will reach out to OSU about availability of Lenovo eMAGs for us
        * has neil spoken to Fabian? - No ; Neil will do this
* RISCv Rocky Port Status
    * Neil - Investigate what and how much riscv hardware we need.. and where we'll host it
        * This probably is going to be a whole bunch of VF2s
        * P670 (16-core - MilkV oasis) would be great, but, upstream support is not yet there. VF2 is a better target for Rocky 9
* Various conversations happened here but Neil was dealing with keeping all the mice in his house dead. The following is second-hand :) 
* Rpi Kernel - Should it live?
    * We want to get rid of it, but we can't yet. Skip says yes
    * Plan:
        * Build the rpi kernel as a variant of the mainline
        * rpi kernel will be subsumed into kernel-mainline-sbc, not further upstream
            * This will allow more obvious contribution to ELrepo for SBCs
        * RPI image will be replaced with a new GenericArm-SBC image produced by Empanadas which includes kernel-mainline-sbc
* Next meetings
    * Dec 29 - Cancel.
    * Jan 12 - Keep

## Action Items

* Neil to actually make tickets for the follow ups / decisions. But, like, for real this time.
* Neil to reach out to people re: ARMHFP hardwares
    * Ampere
    * OSUOSL
    * Fabian (arrfab)
* Neil to figure out what RISCv hardware we need
* Announce Dec 29th meeting cancelation

## Old business

### 2023-10-20

#### Action Items

* Libre Compute - Try/Investigate using vendor tree to build uboot  - Pratham
* Investigate `arm-image-installer` script/tool for helping write disk images for specific boards - Sherif (?)
* Odroid N2 - Track installability
* Orange Pi 5 - Track installability
* Rock5b - Track installability
* Libre Computing Boards (3)
* Maintenance - Importing dependencies from Fedora/EPEL
* Document process on backporting uboot and kernels - Pablo
    * To include information on how we work and interact with upstreams, with examples! - Sherif
* Check and investigate which boards have hardcoded grubx64 paths in their uboot; address them
* Acquire armhfp (arm7vl) hardware - Neil to reach out to OSU OSL
* Neil - Investigate what and how much riscv hardware we need.. and where we'll host it

#### Decisions
    * Images should be generic so as to be able to be installed on any board, where possible.
        * uboot can live on SPI or external flash
        * We need to help document this for our users and have guides on how to get the SBCs working. This is a big pain point for many SBC users as there is so much variation.
            * To this end, we should investigate some tooling to aid in writing images for boards which will boot on the first try.
    * Uboot should similarly be generic and work for all boards, insofar as it is practical to do so.
        * Some boards this doesn't make sense for, e.g., ones that have uboot from 2014 + hundreds of patches, however, these are few and far between. For these, we can package them as RPMs and provide them (see note below re: licensing)
    * We will wait for the next Kernel.org LTS to be cut, as that should have all the changes for the boards we're talking about.
    * We will engage with our upstreams (Fedora, ELRepo, etc) for changes we make with the Kernel SIG for AltArch/SBC support.
        * This necessitates participating in SIG/Kernel to represent our needs in these kernels.
    * We should strive to perform native builds when possible, but recognize that emulation is a necessary evil.

!!! note "uboot and other licensing"
    We need to ensure that we are careful about the licensing of softwares we wish to include in the SIG distribution.

